## GProxyAddress GProxyAddress — An internet address with proxy information |

## Functions

const gchar * | g_proxy_address_get_destination_protocol ()
const gchar * | g_proxy_address_get_destination_hostname ()
guint16 | g_proxy_address_get_destination_port ()
const gchar * | g_proxy_address_get_password ()
const gchar * | g_proxy_address_get_protocol ()
const gchar * | g_proxy_address_get_username ()
const gchar * | g_proxy_address_get_uri ()
GSocketAddress * | g_proxy_address_new ()

## Properties

gchar * | destination-hostname | Read / Write / Construct Only
guint | destination-port | Read / Write / Construct Only
gchar * | destination-protocol | Read / Write / Construct Only
gchar * | password | Read / Write / Construct Only
gchar * | protocol | Read / Write / Construct Only
gchar * | uri | Read / Write / Construct Only
gchar * | username | Read / Write / Construct Only

## Types and Values

| GProxyAddress
struct | GProxyAddressClass

## Object Hierarchy

        GObject
        ╰── GSocketAddress
            ╰── GInetSocketAddress
                ╰── GProxyAddress

## Implemented Interfaces

GProxyAddress implements GSocketConnectable.

## Includes

    #include <gio/gio.h>

## Description

Support for proxied GInetSocketAddress.

## Functions

### g_proxy_address_get_destination_protocol ()

    const gchar *
    g_proxy_address_get_destination_protocol
                                   (GProxyAddress *proxy);

Gets the protocol that is being spoken to the destination server; eg, "http" or "ftp".

#### Parameters

proxy | a GProxyAddress |

#### Returns

the `proxy` 's destination protocol

Since 2.34

### g_proxy_address_get_destination_hostname ()

    const gchar *
    g_proxy_address_get_destination_hostname
                                   (GProxyAddress *proxy);

Gets `proxy` 's destination hostname; that is, the name of the host that will be connected to via the proxy, not the name of the proxy itself.

#### Parameters

proxy | a GProxyAddress |

#### Returns

the `proxy` 's destination hostname

Since 2.26

### g_proxy_address_get_destination_port ()

    guint16
    g_proxy_address_get_destination_port (GProxyAddress *proxy);

Gets `proxy` 's destination port; that is, the port on the destination host that will be connected to via the proxy, not the port number of the proxy itself.

#### Parameters

proxy | a GProxyAddress |

#### Returns

the `proxy` 's destination port

Since 2.26

### g_proxy_address_get_password ()

    const gchar *
    g_proxy_address_get_password (GProxyAddress *proxy);

Gets `proxy` 's password.

#### Parameters

proxy | a GProxyAddress |

#### Returns

the `proxy` 's password

Since 2.26

### g_proxy_address_get_protocol ()

    const gchar *
    g_proxy_address_get_protocol (GProxyAddress *proxy);

Gets `proxy` 's protocol. eg, "socks" or "http"

#### Parameters

proxy | a GProxyAddress |

#### Returns

the `proxy` 's protocol

Since 2.26

### g_proxy_address_get_username ()

    const gchar *
    g_proxy_address_get_username (GProxyAddress *proxy);

Gets `proxy` 's username.

#### Parameters

proxy | a GProxyAddress |

#### Returns

the `proxy` 's username

Since 2.26

### g_proxy_address_get_uri ()

    const gchar *
    g_proxy_address_get_uri (GProxyAddress *proxy);

Gets the proxy URI that `proxy` was constructed from.

#### Parameters

proxy | a GProxyAddress |

#### Returns

the `proxy` 's URI, or `NULL` if unknown

Since 2.34

### g_proxy_address_new ()

    GSocketAddress *
    g_proxy_address_new (GInetAddress *inetaddr,
                         guint16 port,
                         const gchar *protocol,
                         const gchar *dest_hostname,
                         guint16 dest_port,
                         const gchar *username,
                         const gchar *password);

Creates a new GProxyAddress for `inetaddr` with `protocol` that should tunnel through `dest_hostname` and `dest_port` .

(Note that this method doesn't set the “uri” or “destination-protocol” fields; use `g_object_new()` directly if you want to set those.)

#### Parameters

inetaddr | The proxy server GInetAddress. |
port | The proxy server port. |
protocol | The proxy protocol to support, in lower case (e.g. socks, http). |
dest_hostname | The destination hostname the proxy should tunnel to. |
dest_port | The destination port to tunnel to. |
username | The username to authenticate to the proxy server (or `NULL`). | [allow-none]
password | The password to authenticate to the proxy server (or `NULL`). | [allow-none]

#### Returns

a new GProxyAddress

Since 2.26

## Types and Values

### GProxyAddress

    typedef struct _GProxyAddress GProxyAddress;

A GInetSocketAddress representing a connection via a proxy server

Since 2.26

### struct GProxyAddressClass

    struct GProxyAddressClass {
      GInetSocketAddressClass parent_class;
    };

Class structure for GProxyAddress.

Since 2.26

## Property Details

### The `“destination-hostname”` property

      “destination-hostname”     gchar *

The proxy destination hostname.

Flags: Read / Write / Construct Only

Default value: NULL

### The `“destination-port”` property

      “destination-port”         guint

The proxy destination port.

Flags: Read / Write / Construct Only

Allowed values: <= 65535

Default value: 0

### The `“destination-protocol”` property

      “destination-protocol”     gchar *

The protocol being spoke to the destination host, or `NULL` if the GProxyAddress doesn't know.

Flags: Read / Write / Construct Only

Default value: NULL

Since 2.34

### The `“password”` property

      “password”                 gchar *

The proxy password.

Flags: Read / Write / Construct Only

Default value: NULL

### The `“protocol”` property

      “protocol”                 gchar *

The proxy protocol.

Flags: Read / Write / Construct Only

Default value: NULL

### The `“uri”` property

      “uri”                      gchar *

The URI string that the proxy was constructed from (or `NULL` if the creator didn't specify this).

Flags: Read / Write / Construct Only

Default value: NULL

Since 2.34

### The `“username”` property

      “username”                 gchar *

The proxy username.

Flags: Read / Write / Construct Only

Default value: NULL